/******************************************************************
Module : BankAccJ.java - a multithreaded application sample
             Written 2000 by Dmitri Leman
Purpose: To demonstrate ability of tracing framework to collect
    traces from multiple threads using JNI
******************************************************************/

public class BankAccJ implements Runnable
{
    public void run()
    {
        Thread l_Thread = Thread.currentThread();
        for(int i = 0; i < m_iNumLoops &&
            m_iErrorDetected == 0; i++)
        {
            if(m_iAccount < 0)
                return;//error

            if(m_iErrorDetected == 0)
            {
                HTrace.HTrace(HTrace.TG_BankAccount, 
                    "Thread " + l_Thread + 
                    " m_iAccount = " + m_iAccount + 
                    " decide to withdraw\n");
            }

            if(m_iAccount >= 100)
            {
                //The following loop is to create a delay 
                //and increase a chance of m_iAccount corruption
                
                for(int j = 0; j < 1000; j++)
                {
                    m_iDummy++;
                }
                
                m_iAccount -= 100;

                if(m_iErrorDetected == 0)
                {
                    HTrace.HTrace(HTrace.TG_BankAccount, 
                        "Thread " + l_Thread + 
                        " m_iAccount = " + m_iAccount + 
                        " after withdraw\n");
                }
                
                if(m_iAccount < 0)
                {
                    m_iErrorDetected++;
                    HTrace.HTrace(
                        HTrace.TG_BankAccount | HTrace.TG_Error, 
                        "ERROR: Thread " + l_Thread + 
                        " m_iAccount = " + m_iAccount + "\n");
                    return;
                }
            }
            else 
                m_iAccount += 100;

            if(m_iErrorDetected == 0)
            {
                HTrace.HTrace(HTrace.TG_BankAccount, 
                    "Thread " + l_Thread + " m_iAccount = "
                    + m_iAccount + "\n");
            }
        }//for(int i = 0; i < m_iNumLoops; i++)
    }//public void run()
   
    public static void main(String[] p_strArgs)
    {
        HTrace.TraceAssignGroupsToStream(HTrace.TO_MemoryBuffer, 
            HTrace.TG_BankAccount | HTrace.TG_ThreadSwaps, -1);

        HTrace.HTrace(HTrace.TG_BankAccount, "BankAccJ started\n");
        
        m_iNumLoops = 1000*1000;
        int l_iNumThreads = 2;
        for(int i = 0; i < l_iNumThreads; i++)
        {
            BankAccJ l_BankAccJ = new BankAccJ();
            Thread l_Thread = new Thread(l_BankAccJ, "#" + i);
            l_Thread.setDaemon(true);
            l_Thread.start();
        }
        
        System.out.println("Type any key to terminate");
        
        try
        {
            System.in.read();
        }
        catch(Exception e)
        {
        }

    
    }
    static int m_iNumLoops = 0;
    static int m_iAccount = 500;
    static int m_iErrorDetected = 0;
    static int m_iDummy = 0;
}//public class BankAccJ
