//----------------------------------------------------------------------
//
//  Copyright(c) 2001, Richard Nies
//
//  Permission granted to use this code without restriction as
//  long as this copyright notice appears in all source files.
//
//  Class:        ConfigExcep
//
//  File:         ConfigExcep.h
//
//  Description:  Defines a configuration exception.
//               
//----------------------------------------------------------------------
#ifndef _CONFIGEXCEP_H
#define _CONFIGEXCEP_H

// System Includes

// Local Includes

#include "../Common/RunTimeExcep.h"

// Macros

//----------------------------------------------------------------------
// Class: Common Exception (ConfigExcep)
//----------------------------------------------------------------------
class ConfigExcep : public RunTimeExcep
{
public:

   //---
   // Constructors/Destructors
   //---

   ConfigExcep
      (const char* file,
       const char* method,
       const int   line,
       const char* errMsg  = "",
       const int   errCode = 0,
       const char* subID   = "");

   virtual ~ConfigExcep() {}

   //---
   // Information methods.
   //---
     
   virtual const char* id() const;
   // Returns the unique text id to identify this exception.

protected:

   //---
   // Constructors/Destructors
   //---

   ConfigExcep
      (const char* id,
       const char* file,
       const char* method,
       const int   line,
       const char* errMsg,
       const int   errCode,
       const char* subID);
   // Used by derived exception classes.

private:

};  

//----------------------------------------------------------------------
// Inline Method: Constructor
//----------------------------------------------------------------------
inline
ConfigExcep::ConfigExcep
                  (const char* id,
                   const char* file,
                   const char* method,
                   const int   line,
                   const char* errMsg,
                   const int   errCode,
                   const char* subID)     
  :
      RunTimeExcep
         (id, file, method, line, errMsg, errCode, subID)
{}

#endif



