//----------------------------------------------------------------------
//
//  Copyright(c) 2001, Richard Nies
//
//  Permission granted to use this code without restriction as
//  long as this copyright notice appears in all source files.
//
//  Class:        CorbaSystemExcep
//
//  File:         CorbaSystemExcep.cpp
//
//----------------------------------------------------------------------

// System Includes

// Local Includes

#include "../Common/CorbaSystemExcep.h"

// Macros

//----------------------------------------------------------------------
// Method: Constructor
//----------------------------------------------------------------------
CorbaSystemExcep::CorbaSystemExcep
                (const char*                   file,
                 const char*                   method,
                 const int                     line,
                 const CORBA::ULong            minorCode,
                 const CORBA::CompletionStatus status,
                 const char*                   errMsg,
                 const int                     errCode,
                 const char*                   subID) 
  :
     CorbaExcep         (id(), file, method, line, errMsg, errCode, subID),
     m_minorCode        (minorCode),
     m_completionStatus (status)
{}

//----------------------------------------------------------------------
// Method: id
//----------------------------------------------------------------------
const char* CorbaSystemExcep::id() const     
{
   static const char* classId = "CorbaSystemExcep";
   return classId;
}

