/******************************************************************
Module : HTrace.java - a JNI wrapper for tracing framework
             Written 2000 by Dmitri Leman
******************************************************************/

public class HTrace
{
    static
    {
        System.loadLibrary("HTrcJni");
        InitTrace();
    }
    public static void HTrace(int p_dwMask, String p_strMessage)
    {
        if((ms_iConsoleMask & p_dwMask) != 0)
        {
            System.out.println(p_strMessage);
            return;
        }
        
        if((ms_iTotalMask & p_dwMask) != 0)
        {
            HTraceImpl(p_dwMask, p_strMessage);
        }
    }
    
    public static native void InitTrace();
    
    public static native void HTraceImpl(int p_dwMask, String p_strMessage);
    
    public static native void TraceAssignGroupsToStream(
        int p_dwTraceOutputs, int p_dwNewGroupFlags, int p_dwGroupFlagsToModify);
    
//The following definitions were copied from HTrace.h
    
//Groups:
    public static final int TG_BankAccount = 1;//Bank account sample

    public static final int TG_ThreadSwaps = 2;//Thread swap notifications from NT driver

//The following are groups for error messages:
    public static final int TG_MessageBox =  0x1000000;//errors and warnings in application

    public static final int TG_Error      = 0x80000000; //errors
  
    //Output streams:
    public static final int TO_DebugMonitor = 1;
    public static final int TO_File         = 2;
    public static final int TO_FlushFile    = 4;
    public static final int TO_MessageBox   = 8;
    public static final int TO_Console      = 0x10;
    public static final int TO_MemoryBuffer = 0x20;
    public static final int TO_OutputLog    = 0x40;
    
    public static int ms_iTotalMask = 0;
    public static int ms_iConsoleMask = 0;
}//public class HTrace
