/******************************************************************
Module : MeasTime.java - class to measure overhead of tracing
             Written 2000 by Dmitri Leman
******************************************************************/
public class MeasTime
{
    static class MeasureTime
    {
        MeasureTime(int p_iOutputFlag, 
            int p_iNumLoops, String p_strName)
        {
            m_iOutputFlag = p_iOutputFlag;
            m_iNumLoops = p_iNumLoops;
            m_iTime     = 0;
            m_strName   = p_strName;
        }

        void measure()
        {
            int i;
            HTrace.TraceAssignGroupsToStream(m_iOutputFlag, 
                HTrace.TG_BankAccount, HTrace.TG_BankAccount);
            long l_lStart = System.currentTimeMillis();
            for(i = 0; i < m_iNumLoops; i++)
            {
                HTrace.HTrace(HTrace.TG_BankAccount, m_strName);
            }
            long l_lEnd = System.currentTimeMillis();
            m_iTime = (int)(l_lEnd - l_lStart);
            HTrace.TraceAssignGroupsToStream(m_iOutputFlag, 
                0, HTrace.TG_BankAccount);
        }//void measure()
        
        void report(String p_strName)
        {
            HTrace.HTrace(HTrace.TG_BankAccount, p_strName + 
                " Time " + m_iTime + 
                " NumLoops " + m_iNumLoops + 
                " Average ms " + 
                ((m_iTime)*1000/((double)m_iNumLoops)) );
        }
        
        int m_iOutputFlag;
        int m_iNumLoops;
        int m_iTime;
        String m_strName;
    }//class MeasureTime
    
    public static void main(String[] p_strArgs)
    {
        MeasureTime l_MemoryBuffer = 
            new MeasureTime(HTrace.TO_MemoryBuffer, 
            100*1000, "Mem Buffer\n");
        MeasureTime l_Console      = 
            new MeasureTime(HTrace.TO_Console     , 
            1*1000  , "**Console*\n");
        
        l_MemoryBuffer.measure();
        l_Console     .measure();

        HTrace.TraceAssignGroupsToStream
            (HTrace.TO_Console, HTrace.TG_BankAccount, -1);
        
        l_MemoryBuffer.report("Memory Buffer");
        l_Console.report("Console");
        
        try
        {
            System.in.read();
        }
        catch(Exception e)
        {
        }
    }
}//public class MeasTime
