//----------------------------------------------------------------------
//
//  Copyright(c) 2001, Richard Nies
//
//  Permission granted to use this code without restriction as
//  long as this copyright notice appears in all source files.
//
//  Class:        SoftwareExcep
//
//  File:         SoftwareExcep.h
//
//  Description:  Defines an unknown exception.
//               
//----------------------------------------------------------------------
#ifndef _SOFTWAREEXCEP_H
#define _SOFTWAREEXCEP_H

// System Includes

// Local Includes

#include "../Common/CommonExcep.h"

// Macros

//----------------------------------------------------------------------
// Class: Common Exception (SoftwareExcep)
//----------------------------------------------------------------------
class SoftwareExcep : public CommonExcep
{
public:

   //---
   // Constructors/Destructors
   //---

   SoftwareExcep
      (const char* file,
       const char* method,
       const int   line,
       const char* errMsg  = "",
       const int   errCode = 0,
       const char* subID   = "");

   virtual ~SoftwareExcep() {}

   //---
   // Information methods.
   //---
     
   virtual const char* id() const;
   // Returns the unique text id to identify this exception.

protected:

   //---
   // Constructors/Destructors
   //---

   SoftwareExcep
      (const char* id,
       const char* file,
       const char* method,
       const int   line,
       const char* errMsg,
       const int   errCode,
       const char* subID);
   // Used by derived exception classes.

private:

};  

//----------------------------------------------------------------------
// Inline Method: Constructor
//----------------------------------------------------------------------
inline
SoftwareExcep::SoftwareExcep
                  (const char* id,
                   const char* file,
                   const char* method,
                   const int   line,
                   const char* errMsg,
                   const int   errCode,
                   const char* subID)     
  :
      CommonExcep
         (id, file, method, line, errMsg, errCode, subID)
{}

#endif



